﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Microsoft.Practices.Prism.ViewModel;
using UFP.LumberTrack.ViewModeling.Production.Ordered.Sources;
using WpfApplication1.Data;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class WorkOrderSelection
    { 
        public class ViewModel : NotificationObject
        {
            
        /// <summary>
        /// Helper to accomplish filtering in the XamGrid.
        /// </summary>
        private FilterProvisioning m_FilterProvisioning;
        

        /// <summary>
        /// Return a simple object to be used for filter binding in the XamGrid.
        /// </summary>
        public DataRowView GetFilterObject()
        { return m_FilterProvisioning.GetFilterObject(); }
            

            /// <summary>
            /// Table and System.Data event handler.
            /// </summary>
            private WorkOrderData.WorkOrderDataTable m_TableWorkOrder;

            /// <summary>
            /// The private dataview for binding.
            /// </summary>
            private DataView m_WorkOrderDataForBinding = null;

                /// <summary>
            /// Publicly accessible dataview for binding.
            /// Exposed as an IList for XamGrids.
            /// (Although XamGrids understand DataView
            /// a lot better than they let on)
            /// </summary>
            public DataView WorkOrderDataForBinding
            {
                get 
                { 
                    // Create the first time
                    if (m_WorkOrderDataForBinding == null)
                    { m_WorkOrderDataForBinding = new DataView(m_TableWorkOrder, string.Empty, string.Empty, DataViewRowState.CurrentRows); }

                    // Return it
                    return m_WorkOrderDataForBinding;
                }
            }


            /// <summary>
            /// Construction
            /// c:\temp\WorkOrder.xml
            /// </summary>
            public ViewModel(string p_File)
            {
                m_FilterProvisioning = new FilterProvisioning();

                WorkOrderData DataTemp = new WorkOrderData();
                if(!string.IsNullOrEmpty(p_File))
                { DataTemp.ReadXml(p_File); }

                m_TableWorkOrder = new WorkOrderData.WorkOrderDataTable();
                foreach(WorkOrderData.WorkOrderRow RowLoop in DataTemp.WorkOrder)
                { m_TableWorkOrder.ImportRow(RowLoop); }
                
              
                        
            }
        }
    }

}
