﻿using System;
using System.IO;
using System.Data;
using System.Runtime.InteropServices;
using System.Windows.Threading;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Interop;
using System.Windows.Forms.Integration;
using System.Windows.Controls.Primitives;
using System.ComponentModel.Composition;
using System.ComponentModel;

using Infragistics.DragDrop;
using Infragistics.Controls.Grids;
 

using Infragistics.Persistence;
using System.Xml.Linq;
using System.Globalization;

namespace WpfApplication1
{
    
 
     

    /// <summary>
    /// Interaction logic for WorkOrderSelection 
    /// 
    /// My MEF exports aren't discoverable (IEndActiveEdits)
    /// </summary>
    public partial class WorkOrderSelection :  
        UserControl 
    {
       
        /// <summary>
        /// View model
        /// </summary>
        public ViewModel ViewModelContext 
        { get { return (ViewModel)DataContext; } }

         

         
        


        /// <summary>
        /// Get the parent that has the given type.
        /// </summary>
        private T GetUserInterfaceParentElement<T>(UIElement p_Element) where T : UIElement
        {
            // Start with the one given
            UIElement ParentObj = p_Element;
            while (ParentObj != null)
            {
                // Change type if possible
                T TypedObj = ParentObj as T;
                if (TypedObj != null)
                { return TypedObj; }

                // Go up the truee
                ParentObj = VisualTreeHelper.GetParent(ParentObj) as UIElement;
            }

            // Never found
            return null;
        } 


 
        /// <summary>
        /// Get the first child of the given type.
        /// </summary>
        private T GetFirstVisualChild<T>(Visual p_Parent) where T : Visual
        {  return GetAllVisualChildren<T>(p_Parent).FirstOrDefault(); }

        /// <summary>
        /// Get all immediate children of the specified type.
        /// </summary>
        private IEnumerable<T> GetAllVisualChildren<T>(Visual p_Parent) where T : Visual
        {    
            // Return nothing
            if(p_Parent == null) 
            { yield break; }

            // Return a list
            T ChildObj = default(T);    
            for (int i = 0; i < VisualTreeHelper.GetChildrenCount(p_Parent); i++)    
            {   
                // Get the child
                ChildObj = (Visual)VisualTreeHelper.GetChild(p_Parent, i) as T;        
                if (ChildObj == null) continue;

                // Send it back
                yield return ChildObj;      
            }    
        }

        /// <summary>
        /// Use a specific path to a visual child of a given type.
        /// </summary>
        private T0 GetVisualChild<T0,T1,T2,T3,T4>(Visual p_Parent) 
            where T0 : Visual
            where T1 : Visual
            where T2 : Visual
            where T3 : Visual
            where T4 : Visual
        { return GetFirstVisualChild<T0>(GetFirstVisualChild<T1>(GetFirstVisualChild<T2>(GetFirstVisualChild<T3>(GetFirstVisualChild<T4>(p_Parent))))); }

        
        /// <summary>
        /// Access to resource dictionary entry for special persistence of column layouts 
        /// (columns visible, column positioning, etc).
        /// </summary>
        private PersistenceSettings ColumnLayoutPersistenceSettings
        { get{ return (PersistenceSettings)Resources["ColumnLayoutPersistenceSettings"]; }  }
        
        /// <summary>
        /// Access to resource dictionary entry for special persistence of column filters.
        /// </summary>
        private PersistenceSettings ColumnFilterPersistenceSettings
        { get{ return (PersistenceSettings)Resources["ColumnFilterPersistenceSettings"]; }  }
        

        /// <summary>
        /// Access to resource dictionary entry for special persistence .
        /// </summary>
        private PersistenceSettings AllSavedPersistenceSettings
        { get{ return (PersistenceSettings)Resources["AllSavedPersistenceSettings"]; }  }


        /// <summary>
        /// Assign the data context, usually in the constructor.
        /// </summary>
        private void AssignDataContext(ViewModel p_ViewModelContext)
        {
            // Some properties are interesting in code
            p_ViewModelContext.PropertyChanged += ViewModel_PropertyChanged;

            

            // Assign it
            DataContext = p_ViewModelContext;
        }


          
        /// <summary>
        /// Constructor
        /// </summary>
        public WorkOrderSelection( )
        {
            // Initialize
            InitializeComponent();

            // Nothing to do in design mode
            if(System.ComponentModel.DesignerProperties.GetIsInDesignMode(this)) return;
             
            
            // Create the view model
            ViewModel ViewModelObj = new ViewModel(@"c:\temp\WorkOrder.xml");
             

            // Data context
            AssignDataContext(ViewModelObj);
        }
         

        /// <summary>
        /// Loaded event.  By now our parent has given us
        /// AppServerInfo and an ActiveBranch.
        /// </summary>
        private void ThisControl_Loaded(object sender, RoutedEventArgs e)
        {
            // Nothing to do in design mode
            if(System.ComponentModel.DesignerProperties.GetIsInDesignMode(this)) return;

        }
       

        /// <summary>
        /// Allows us to change cursor when viewmodel is busy with a long-running operation.
        /// (These are operations that are self-initiated.)
        /// </summary>
        void ViewModel_PropertyChanged(object p_Sender, System.ComponentModel.PropertyChangedEventArgs p_Args)
        {
            // Interesting
            IEnumerable<string> InterestingProperties = new string [] {
                "IsBusyWithSelfInitiatedOperation", 
                "ActiveItemForBinding", 
                "ActiveSelectedItem", 
                "CurrentlySelectedItem"};

            // Handle busy property or active item changing on viewmodel
            if(!InterestingProperties.Contains(p_Args.PropertyName)) return;

                                                        
            

        }

        /// <summary>
        /// Find the Windows form.
        /// (we need this to use winforms features that haven't yet been written in WPF)
        /// </summary>
        public System.Windows.Forms.Form FindWinForm(Visual p_ElementVisual)
        {
            // Use helper method
            HwndSource HwndSourceObj = PresentationSource.FromVisual(p_ElementVisual) as HwndSource;

            // Nothing
            if(HwndSourceObj == null)
            { return null; }
            
            // Back to the element host
            ElementHost ElementVisualHost = System.Windows.Forms.Control.FromChildHandle(HwndSourceObj.Handle) as ElementHost;
            return ElementVisualHost.FindForm();
        }

        /// <summary>
        /// Show all columns.
        /// </summary>
        public void ExecuteShowAllColumns()
        {
            ColumnLayout ColumnLayoutObj = m_XamGrid.ColumnLayouts.First();

            // Show all
            foreach(ColumnBase LoopColumn in ColumnLayoutObj.Columns)
            {
                if (LoopColumn.Visibility == System.Windows.Visibility.Visible) {  continue; }
                if (LoopColumn.IsHideable == false) {  continue; }
                LoopColumn.Visibility = System.Windows.Visibility.Visible;
            }


        }


        /// <summary>
        /// Show the column chooser.
        /// </summary>
        public void ExecuteShowColumnChooser()
        {
            m_XamGrid.ShowColumnChooser();
        }


        /// <summary>
        /// Nothing to do
        /// </summary>
        public void ExecuteTest()
        {

             
        }
            
            
        /// <summary>
        /// Oddly we can mark this Handled without causing problems.
        /// Otherwise the XamGrid uses it to steal focus back from our preview window
        /// (see CellControl_MouseDoubleClick above).
        /// </summary>
        private void CellControl_MouseLeftButtonDown(object sender, MouseButtonEventArgs p_Args)
        {
            p_Args.Handled = true;
        }

        
      


        /// <summary>
        /// The context menu is opened.
        /// </summary>
        private void OnOpened(object p_Sender, RoutedEventArgs p_Args) { }

        /// <summary>
        /// Context menu closed.
        /// </summary>
        private void OnClosed(object sender, RoutedEventArgs e)
        { }

          
                   
        /// <summary>
        /// Filter support for the XamGrid requires an empty object.
        /// </summary>
        private void m_XamGrid_DataObjectRequested(object sender, DataObjectCreationEventArgs p_Args)
        {
            // Must be datarowview
            if (p_Args.ObjectType != typeof(DataRowView))
            { throw new ArgumentException("Unsupported type for filtering table."); }

            // Send it back
            p_Args.NewObject = ViewModelContext.GetFilterObject(); 
        }   
         
            

         
        /// <summary>
        /// This event is raised when a Cell comes into the viewport of the XamGrid
        /// We wire up all cells to support drag/drop of the current row.
        /// </summary>
        private void m_XamGrid_CellControlAttached(object p_Sender, CellControlAttachedEventArgs p_Args)
        {
            

        }


        /// <summary>
        /// No editing the readonly rows 
        /// (cancel when row "IsReadOnly")
        /// </summary>
        private void m_XamGrid_CellEnteringEditMode(object sender, BeginEditingCellEventArgs p_Args)
        {
            


        }

        /// <summary>
        /// Preview keyboard and look for spacebar.
        /// This will toggle the check (if conditions allow)
        /// </summary>
        private void m_XamGrid_PreviewKeyDown(object p_Sender, KeyEventArgs p_Args)
        {
            // Quick exit
            if(p_Args.Key != Key.Space) return;
            //if(ViewModelContext.ActiveSelectedItem == null) return;
            //if(ViewModelContext.ActiveBrowseType != ViewModel.OrderManagementBrowseType.WorkOrders) return;

            
        }

        /// <summary>
        /// Get the keys that are filterable.
        /// </summary>
        private IEnumerable<string> GetFilterableColumnKeys()
        {
            // Get the column base
            IEnumerable<ColumnBase> ListBase;
            ListBase = m_XamGrid.Columns.Where(p => 
            {
                // Text columns are
                // filterable (sometimes)
                if(p is TextColumn)
                { return ((TextColumn)p).IsFilterable; }

                // Non filterable
                return false;
            } );

            // Get the keys
            return ListBase.Select(p => p.Key);

        }

          

        
        /// <summary>
        /// IUserDataGridPersistence
        /// Set persistence information as specified.
        /// </summary>
        public void SetDataGridPersistence(XElement p_ColumnFilter)
        {
            // Locals
            Stream StreamObj;

            // No column visibility yet
            bool m_IsColumnVisibilityPrepared = false;

            try // ... and return status of visibility
	        {	        
               
                { 
                    // Load the stream
                    StreamObj = new MemoryStream(); 
                    p_ColumnFilter.Save(StreamObj);      
                    StreamObj.Position = 0;   

                    // Load the grid.
                    PersistenceManager.Load(m_XamGrid, StreamObj, AllSavedPersistenceSettings);
                }
		        
	        }
	        finally
	        {
                // Column visibility is now prepared
		        m_IsColumnVisibilityPrepared = true;   
	        }

        }






         

        /// <summary>
        /// IUserDataGridPersistence implementation.
        /// Get persistence information.
        /// Get the persistence as XML from PersistenceManager.
        /// </summary>
        /// <param name="p_ColumnLayout">Always return this with layout</param>
        /// <param name="p_ColumnFilter">
        ///     Only return this when user actually has filters (IUserColumnFiltering.IsUserFilteringColumns).  Otherwise null
        /// </param>
        public XElement GetDataGridPersistence( )
        {
            // Locals
            MemoryStream StreamObj;
            StreamReader SettingsReaderObj;
            XDocument XmlResultsDocument;

                                                        
            {
                // Save with specified settings
                StreamObj = new MemoryStream();
                StreamObj = PersistenceManager.Save(m_XamGrid, ColumnFilterPersistenceSettings);
                SettingsReaderObj = new StreamReader(StreamObj);

                // Reset stream position and 
                // load settings into XML doc
                SettingsReaderObj.BaseStream.Position = 0;
                XmlResultsDocument = XDocument.Load(SettingsReaderObj);

                // Get the ones having conditions
                IEnumerable<RowsFilter> ListRowsFilters;
                ListRowsFilters = m_XamGrid.FilteringSettings.RowFiltersCollection.Cast<RowsFilter>().Where(p => { return p.Conditions.Count > 0; } );

                // Filtered columns.  Already ordered well enough.
                var FilteredColumns =   from RowsFilter LoopFilter in ListRowsFilters
                                        where !(string.IsNullOrWhiteSpace(LoopFilter.Column.HeaderText))
                                        select LoopFilter.Column.HeaderText;

                // Return now
                return XmlResultsDocument.Root;
                 



            }
        }





         


        /// <summary>
        /// IUserColumnFiltering
        /// </summary>
        public bool IsUserFilteringColumns
        { 
            get  
            {  
                // Get the ones having conditions
                IEnumerable<Infragistics.IRecordFilter> ListRowsFilters;
                ListRowsFilters = m_XamGrid.FilteringSettings.RowFiltersCollection.Where(p => { return p.Conditions.Count > 0; } );

                // Get the ones having conditions
                return ListRowsFilters.Count() > 0; 
            }  
        }





        /// <summary>
        /// IUserColumnFiltering
        /// </summary>
        public void ClearUserColumnFilters()
        {
            m_XamGrid.FilteringSettings.RowFiltersCollection.Clear();
        }
        
         

        
        /// <summary>
        /// Don't expose me as a System.Windows.Window.
        /// IProvideParentForWindow
        /// </summary>
        public Window ParentWindowForDialogs
        { get { return null; } }

        /// <summary>
        /// Because I am normally on a WinForms Window.
        /// IProvideParentForWindow
        /// </summary>
        public System.Windows.Forms.Form ParentFormForDialogs
        { get { return FindWinForm(this); } }

        /// <summary>
        /// Stuff has been filtered.
        /// </summary>
        private void m_XamGrid_Filtered(object p_Sender, FilteredEventArgs p_Args)
        {
            // Ask the commandmanager to requery CanExecute
            CommandManager.InvalidateRequerySuggested();
             
        }

        /// <summary>
        /// Event handlers to be used someday (debuggable for now)
        /// </summary>
        private void m_XamGrid_ColumnLayoutAssigned(object sender, ColumnLayoutAssignedEventArgs e)
        {

        }

        private void m_XamGrid_ColumnResized(object sender, ColumnResizedEventArgs e)
        {

        }

        private void m_XamGrid_ColumnFixedStateChanged(object sender, ColumnFixedStateEventArgs e)
        {

        }

        private void m_XamGrid_ColumnSorted(object sender, SortedColumnEventArgs e)
        {

        }

        private void m_XamGrid_ColumnVisibilityChanged(object sender, ColumnVisibilityChangedEventArgs e)
        {

        }

        private void m_XamGrid_SelectedRowsCollectionChanged(object sender, SelectionCollectionChangedEventArgs<SelectedRowsCollection> e)
        {

        }


         







    }
}



